﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;

public partial class Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.WebHierarchicalDataGrid1.DataSource = GetData();
        this.WebHierarchicalDataGrid1.DataBind();
    }

    #region Creating DataSet

    public List<TableContent> GetData()
    {
        List<TableContent> list = new List<TableContent>();
        TableContent tc;
        for (int i = 0; i < 10; i++)
        {
            tc = new TableContent();
            tc.ClaimNumber = "CLM12345678" + i;
            tc.PatientLastName = "Sear";
            tc.PatientFirstName = "Pat";
            tc.SSN = "1234568789";
            tc.InjuryDate = DateTime.Now.AddDays(i % 2 == 0 ? -1000 : -500); ;
            tc.Value = 10 * (10 % (2 + i));
            list.Add(tc);
        }
        return list;
    }

    #endregion
    protected void WebHierarchicalDataGrid1_GroupedRowInitialized(object sender, GroupedRowEventArgs e)
    {
        ContainerGrid grid = sender as ContainerGrid;
        foreach (GroupedRecord groupedRow in grid.GroupedRows)
        {
            SetGroupText(groupedRow, e);
        }
    }

    protected void SetGroupText(GroupedRecord groupedRow, GroupedRowEventArgs e)
    {
        decimal valTotal = 0;
        int valRowCount = 0;
        string colName = "";
        groupedRow.Rows.Reset();
        while (groupedRow.Rows.MoveNext())
        {
            ContainerGridRecord row = (ContainerGridRecord)groupedRow.Rows.Current;
            Infragistics.Web.UI.GridControls.WHDGListNode node = row.DataItem as Infragistics.Web.UI.GridControls.WHDGListNode;
            TableContent tc = node.Item as TableContent;
            valTotal += tc.Value;
            valRowCount++;
            colName = WebHierarchicalDataGrid1.Columns[groupedRow.ColumnGroupedBy.Index].Header.Text;
            //if (groupedRow.ChildGroupRows.Count > 0)
            //{
            //    foreach (GroupedRecord groupedChildRow in groupedRow.ChildGroupRows)
            //    {
            //        SetGroupText(groupedChildRow, e);
            //    }
            //}
        }
        groupedRow.Text = "Column : \"" + colName + "\"   Count: " + valRowCount.ToString() + "  Total value from Column \"Value\": " + valTotal;
    }
    protected void WebHierarchicalDataGrid1_GroupedColumnsChanging(object sender, GroupedColumnsChangingEventArgs e)
    {

    }
}

public class TableContent
{
    public string ClaimNumber { get; set; }
    public string PatientLastName { get; set; }
    public string PatientFirstName { get; set; }
    public string SSN { get; set; }
    public DateTime InjuryDate { get; set; }
    public int Value { get; set; }
}
